<template>
  <div class="item">
    <h2 class="item-100">{{ company.name }}</h2>
    <div class="item-100">
      <img class="item-logo" v-bind:src="company.logo" />
    </div>
    <div class="item-50-bold">Established</div>
    <div class="item-50">{{ company.established }}</div>
    <div class="item-50-bold">Employees</div>
    <div class="item-50">{{ formatNumber(company.employees) }}</div>
    <div class="item-50-bold">Revenue</div>
    <div class="item-50">{{ formatNumber(company.revenue) }} &euro;</div>
    <div class="item-50-bold">Net income</div>
    <div class="item-50">{{ formatNumber(company.netIncome) }} &euro;</div>
    <div class="item-50-bold">Market capitalization</div>
    <div class="item-50">
      {{ formatNumber(company.marketCapitalization) }} &euro;
    </div>
    <div class="item-50-bold">Dividend yield</div>
    <div class="item-50">{{ formatNumber(company.dividendYield * 100) }} %</div>
    <div class="item-100-center">
      <button @click="openCompanyEditPopup">Modify</button>
      <button class="button-red" @click="deleteCompany">Delete</button>
    </div>
  </div>
  <Popup
    v-if="popupOpen"
    :conf="popupConfig"
    @popup-closed="closePopup"
    @action-completed="emitActionCompleted"
  >
    <CompanyEdit :company="company" />
  </Popup>
</template>

<script>
import Popup from "./Popup.vue";
import PopupConfig from "./PopupConfig";
import CompanyEdit from "./CompanyEdit.vue";
import Util from "../util/Util";
import FetchApi from "../util/FetchApi";

export default {
  name: "CompanyItem",
  props: {
    company: null,
  },
  data() {
    return {
      popupOpen: false,
      popupConfig: PopupConfig.POPUP_CONF_DEFAULT,
    };
  },
  emits: ["company-deleted", "action-completed"],
  methods: {
    async deleteCompany() {
      if (confirm("Do you really want to delete the company?")) {
        try {
          await FetchApi.deleteCompany(this.company.id);
          this.$emit("company-deleted", this.company.id);
        } catch (e) {
          Util.handleError(e, () => this.$router.push({ name: "Login" }));
        }
      }
    },
    async openCompanyEditPopup() {
      this.popupOpen = true;
    },
    emitActionCompleted() {
      this.closePopup();
      this.$emit("action-completed");
    },
    closePopup() {
      this.popupOpen = false;
    },
    formatNumber(num) {
      if (num === null) {
        return "0";
      }
      num = Math.round(num * 100) / 100;
      return num.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
    },
  },
  components: {
    Popup,
    CompanyEdit,
  },
};
</script>